// SourceMod Script
// Developed by Misery
// MARS 2009

#pragma semicolon 1
#include <sourcemod>
#include <sdktools>
//#include <geoip>

#undef REQUIRE_EXTENSIONS
#define PLUGIN_VERSION "0.10.20"
#define AWARDS 19

public Plugin:myinfo = {
    name = "Dods Stats with caps, headshots, awards, ...",
    author = "Misery",
    description = "Stats, Awards and Ranking",
    version = PLUGIN_VERSION,
    url = "http://the-suprem.verygames.net"
};

new Handle:Cvar_InfoDodStats[MAXPLAYERS + 1];
new Handle:Cvar_dodstats_enabled = INVALID_HANDLE;
//new Handle:Cvar_dodstats_tk_penalty = INVALID_HANDLE;
new Handle:Cvar_dodstats_hidechat = INVALID_HANDLE;
new Handle:db = INVALID_HANDLE;

new String:tableau_des_awards[][] = {
	"Рядовой",
	"Ефрейтор",
	"Младший сержант",
	"Сержант",
	"Старший сержант",
	"Старшина",
	"Прапорщик",
	"Старший прапорщик",
	"Младший Лейтенант",
	"Лейтенант",
	"Старший Лейтенант",
	"Капитан",
	"Майор",
	"Подполковник",
	"Полковник",
	"Генерал-майор",
	"Генерал-лейтенант",
	"Генерал-полковник",
	"Маршал"
	};

// new tableau_des_caps[] = { 0, 83, 167, 260, 326, 407, 636, 795, 993, 1242, 1552, 2425, 3032, 3790, 4737, 5833, 7500, 10000, 17500 };
new tableau_des_caps[] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
new tableau_des_tues[] = { 0, 250, 500, 781, 977, 1221, 1907, 2384, 2980, 3725, 5821, 7276, 9095, 11369, 14211, 17500, 22500, 30000, 52500 };

new dod_stats_score[MAXPLAYERS+1];
new dod_stats_kills[MAXPLAYERS+1];
new dod_stats_deaths[MAXPLAYERS+1];
new dod_stats_captures[MAXPLAYERS+1];
new dod_stats_headshots[MAXPLAYERS+1];
new dod_stats_teamkills[MAXPLAYERS+1];
new dod_stats_teamkilled[MAXPLAYERS+1];
new dod_stats_time_joined[MAXPLAYERS+1];
new dod_stats_time_played[MAXPLAYERS+1];
new bool:sqlite = false;
new dod_global_player_count;

public OnPluginStart(){
	decl String:error[256];
	if(SQL_CheckConfig("dod_stats"))
		db = SQL_Connect("dod_stats", true, error, sizeof(error));
	/* else
		db = SQL_Connect("storage-local", true, error, sizeof(error)); */
	
	if(db == INVALID_HANDLE){
		LogError("Could not connect to database: %s", error);
		return;
	}
	
	decl String:driver[16];
	SQL_ReadDriver(db, driver, sizeof(driver));
	if(strcmp(driver, "mysql", false)==0){
		sqlite = false;
	}else if(strcmp(driver, "sqlite", false)==0){
		sqlite = true;
	}else{
		LogError("Invalid database type");
		return;
	}
	
	SQL_TQuery(db, SQLErrorCheckCallback, "CREATE TABLE IF NOT EXISTS dod_stats (steamid varchar(255) NOT NULL default '', name varchar(255) NOT NULL default '', score int(12) NOT NULL default 0, kills int(12) NOT NULL default 0, deaths int(12) NOT NULL default 0, captures int(12) NOT NULL default 0, headshots int(12) NOT NULL default 0, teamkills int(12) NOT NULL default 0, teamkilled int(12) NOT NULL default 0, timeplayed int(12) NOT NULL default 0, last_connect timestamp NOT NULL default CURRENT_TIMESTAMP)");
	
	CreateConVar("sm_dodstats_version", PLUGIN_VERSION, "Dods Stats, Awards & Ranking version", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);
	Cvar_dodstats_enabled = CreateConVar("sm_dodstats_enabled", "1", "Enables or Disables Dods Stats, Awards & Ranking", FCVAR_PLUGIN);
	//Cvar_dodstats_tk_penalty = CreateConVar("sm_dodstats_tk_penalty", "0", "Amount of points to take on tk, 0 to disable", FCVAR_PLUGIN);
	Cvar_dodstats_hidechat = CreateConVar("sm_dodstats_hidechat", "0", "Top, topgrades and statsme are hidden from chat", FCVAR_PLUGIN);
	
	RegConsoleCmd("say", console_say);
	RegConsoleCmd("say_team", console_say);
	RegConsoleCmd("sm_stats", info_stats);
	
	RegAdminCmd("sm_dodstats_reset", AdminCmd_Reset, ADMFLAG_CONFIG, "Reset all Stats");
	RegAdminCmd("sm_dodstats_purge", AdminCmd_Purge, ADMFLAG_CONFIG, "Delete players who haven't played for # of days");
	RegAdminCmd("sm_dodstats_delete_player", AdminCmd_Del_Player, ADMFLAG_CONFIG, "Delete a player of the database");
	
	HookEvent("player_hurt",  Event_Player_Hurt);
	HookEvent("player_death", Event_Player_Death);
	HookEvent("dod_point_captured", Event_Point_Captured);
	
	GetPlayerCount();
}

public Action:AdminCmd_Reset(client, args){
	SQL_TQuery(db, SQLErrorCheckCallback, "DELETE FROM dod_stats");
	PrintToChatAll("\x04[RANK]\x01 Статистика обнулена.");
	return Plugin_Handled;
}

public Action:AdminCmd_Purge(client, args){
	if(args != 1){
		PrintToConsole(client, "Usage: sm_dodstats_purge <days>");
		return Plugin_Handled;
	}
	decl String:arg1[192];
	if(!GetCmdArg(1, arg1, sizeof(arg1))){
		PrintToConsole(client, "Usage: sm_dodstats_purge <days>");
		return Plugin_Handled;
	}
	new days = StringToInt(arg1);
	if(days <= 0){
		PrintToConsole(client, "Invalid number of days.");
		return Plugin_Handled;
	}
	decl String:query[128];
	if(sqlite)
		Format(query, 128, "DELETE FROM dod_stats WHERE last_connect < datetime('now', '-%i days');", days);
	else if(!sqlite)
		Format(query, 128, "DELETE FROM dod_stats WHERE last_connect < current_timestamp - interval %i day;", days);
	SQL_TQuery(db, SQLErrorCheckCallback, query);
	PrintToChatAll("\x04[RANK]\x01 Игрок, который не играл более чем %i дней, будет удален из базы данных", days);
	return Plugin_Handled;
}

public Action:AdminCmd_Del_Player(client, args){
	if(args == 1){
		decl String:arg[MAX_NAME_LENGTH];
		GetCmdArg(1, arg, sizeof(arg));
		decl String:query[128];
		Format(query, 128, "DELETE FROM dod_stats WHERE steamid = '%s';", arg);
		SQL_TQuery(db, SQLErrorCheckCallback, query);
		PrintToChatAll("\x04[RANK]\x01 Из базы удален: %s", arg);
		dod_global_player_count -= 1;
		return Plugin_Handled;
	}else if(args > 1)
		PrintToConsole(client, "Usage: sm_dodstats_delete_player <STEAM_ID>");
	return Plugin_Handled;
}

public Action:console_say(client, args){
	if(!GetConVarBool(Cvar_dodstats_enabled) || client <=0)
		return Plugin_Continue;
	
	decl String:text[192];
	if(!GetCmdArgString(text, sizeof(text)))
		return Plugin_Continue;
	new startidx = 0;
	if(text[strlen(text)-1] == '"'){
		text[strlen(text)-1] = '\0';
		startidx = 1;
	}
	if(strcmp(text[startidx], "rank", false) == 0 || strcmp(text[startidx], "!rank", false) == 0){
		ShowRank(client);
		return Plugin_Handled;
	}
	if(strcmp(text[startidx], "top10", false) == 0 || strcmp(text[startidx], "!top10", false) == 0){
		ShowTop(client);
		if(GetConVarBool(Cvar_dodstats_hidechat))
			return Plugin_Handled;
	}
	if(strcmp(text[startidx], "top", false) == 0 || strcmp(text[startidx], "!top", false) == 0){
		ShowTopGrades(client);
		if(GetConVarBool(Cvar_dodstats_hidechat))
			return Plugin_Handled;
	}
	/* if(strcmp(text[startidx], "grades", false) == 0 || strcmp(text[startidx], "!grades", false) == 0 || strcmp(text[startidx], "grade", false) == 0 || strcmp(text[startidx], "!grade", false) == 0){
		ShowMOTDPanel(client,"Grades", "http://lastwar.game-team.fr/dod/telechargements/motd_grades.html", MOTDPANEL_TYPE_URL);
		if(GetConVarBool(Cvar_dodstats_hidechat))
			return Plugin_Handled;
	} */
	if(strcmp(text[startidx], "stats", false) == 0 || strcmp(text[startidx], "statsme", false) == 0 || strcmp(text[startidx], "!stats", false) == 0 || strcmp(text[startidx], "!statsme", false) == 0){
		ShowStats(client, client);
		if(GetConVarBool(Cvar_dodstats_hidechat))
			return Plugin_Handled;
	}
	return Plugin_Continue;
}

public GetPlayerCount(){
	new Handle:query = SQL_Query(db, "SELECT COUNT(*) FROM dod_stats");
	if(query == INVALID_HANDLE)
		return;
	dod_global_player_count = SQL_FetchInt(query, 0);
	CloseHandle(query);
}

public Action:info_stats(client, args){
	if(args != 1){
		PrintToConsole(client, "Usage: sm_stats <#userid|name>");
	}else if(args == 1){
		decl String:arg[MAX_NAME_LENGTH];
		if(!GetCmdArgString(arg, sizeof(arg))){
			PrintToConsole(client, "Usage: sm_stats <#userid|name>");
			return Plugin_Handled;
		}
		new target = FindTarget(client, arg);
		if(target != 0)
			ShowStats(client, target);
	}
	return Plugin_Handled;
}

public OnClientPutInServer(client){
	if(GetConVarBool(Cvar_dodstats_enabled) && client != 0 && IsClientConnected(client) && !IsFakeClient(client)){
		decl String:client_steamid[128], String:query[256];
		GetClientAuthString(client, client_steamid, sizeof(client_steamid));
		Format(query, sizeof(query), "SELECT score, kills, deaths, captures, headshots, teamkills, teamkilled, timeplayed FROM dod_stats WHERE steamid = '%s'", client_steamid);
		SQL_TQuery(db, SQLQueryConnect, query, GetClientUserId(client));
		dod_stats_time_joined[client] = GetTime();
		Cvar_InfoDodStats[client] = CreateTimer(30.0, InfoDodStats, client, TIMER_FLAG_NO_MAPCHANGE);
	}
}

public OnClientDisconnect(client){
	if(GetConVarBool(Cvar_dodstats_enabled) && client !=0 && !IsFakeClient(client)){
		if(Cvar_InfoDodStats[client] != INVALID_HANDLE){
			CloseHandle(Cvar_InfoDodStats[client]);
			Cvar_InfoDodStats[client] = INVALID_HANDLE;
		}
	}
}

public SQLQueryConnect(Handle:owner, Handle:hndl, const String:error[], any:data){
	new client;
	if(hndl != INVALID_HANDLE){
		if((client = GetClientOfUserId(data))==0)
			return;
		
		decl String:query[512], String:client_name[256], String:client_steamid[128];
		GetClientName(client, client_name, sizeof(client_name));
		ReplaceString(client_name, sizeof(client_name), "'", "");
		GetClientAuthString(client, client_steamid, sizeof(client_steamid));
		if(!SQL_MoreRows(hndl)){
			Format(query, sizeof(query), "INSERT INTO dod_stats (steamid, name, score, kills, deaths, captures, headshots, teamkills, teamkilled, timeplayed, last_connect) VALUES ('%s', '%s', 0, 0, 0, 0, 0, 0, 0, 0, current_timestamp)", client_steamid, client_name);
			SQL_TQuery(db, SQLErrorCheckCallback, query);
			
			dod_stats_score[client] = 0;
			dod_stats_kills[client] = 0;
			dod_stats_deaths[client] = 0;
			dod_stats_captures[client] = 0;
			dod_stats_headshots[client] = 0;
			dod_stats_teamkills[client] = 0;
			dod_stats_teamkilled[client] = 0;
			dod_stats_time_joined[client] = GetTime();
			dod_stats_time_played[client] = 0;
			dod_global_player_count++;
		}else{
			Format(query, sizeof(query), "UPDATE dod_stats SET name = '%s', last_connect = current_timestamp WHERE steamid = '%s'", client_name, client_steamid);
			SQL_TQuery(db, SQLErrorCheckCallback, query);
			while(SQL_FetchRow(hndl)){
				dod_stats_score[client] = SQL_FetchInt(hndl, 0);
				dod_stats_kills[client] = SQL_FetchInt(hndl, 1);
				dod_stats_deaths[client] = SQL_FetchInt(hndl, 2);
				dod_stats_captures[client] = SQL_FetchInt(hndl, 3);
				dod_stats_headshots[client] = SQL_FetchInt(hndl, 4);
				dod_stats_teamkills[client] = SQL_FetchInt(hndl, 5);
				dod_stats_teamkilled[client] = SQL_FetchInt(hndl, 6);
				dod_stats_time_played[client] = SQL_FetchInt(hndl, 7);
			}
		}
	}
}

public SQLErrorCheckCallback(Handle:owner, Handle:hndl, const String:error[], any:data){
	if(!StrEqual("", error))
		LogError("Query failed: %s", error);
}

public ShowRank(client){
	decl String:query[512];
	Format(query, sizeof(query), "SELECT DISTINCT score FROM dod_stats WHERE score > %i ORDER BY score ASC;", dod_stats_score[client]);
	SQL_TQuery(db, SQLQueryRank, query, GetClientUserId(client));
}

public ShowTop(client){
	decl String:query[512];
	//Format(query, sizeof(query), "SELECT name, score, kills, deaths, captures FROM dod_stats ORDER BY score DESC LIMIT 10");
	Format(query, sizeof(query), "SELECT name, score, kills, deaths FROM dod_stats ORDER BY score DESC LIMIT 10");
	SQL_TQuery(db, SQLQueryTop, query, GetClientUserId(client));
}

public ShowTopGrades(client){
	decl String:query[512];
	Format(query, sizeof(query), "SELECT name, captures, kills FROM dod_stats ORDER BY kills DESC LIMIT 10");
	SQL_TQuery(db, SQLQueryTopGrades, query, GetClientUserId(client));
}

public SQLQueryRank(Handle:owner, Handle:hndl, const String:error[], any:data){
	new client;
	if(hndl != INVALID_HANDLE){
		if((client = GetClientOfUserId(data))==0)
			return;
		new rank = SQL_GetRowCount(hndl);
		new next_score = 0;
		new bool:rankup = true;
		if(SQL_HasResultSet(hndl) && SQL_FetchRow(hndl)){
			rank = SQL_GetRowCount(hndl);
			rank += 1;
			rankup = false;
			next_score = SQL_FetchInt(hndl, 0);
		}
		if(rankup)
			rank += 1;
		RankDisplay(client, rank, next_score);
	}
}

public RankDisplay(client, rank, next_score){
	new delta = 0;
	if(next_score > dod_stats_score[client])
		delta = next_score - dod_stats_score[client];
	new x;
	for(new i=0;i<AWARDS;i++){
		if(dod_stats_captures[client] >= tableau_des_caps[i] &&  dod_stats_kills[client]  >= tableau_des_tues[i])
			x = i;
	}
	
	decl String:text[256], String:client_name[64];
	GetClientName(client, client_name, sizeof(client_name));
	if(delta != 0)
		Format(text, sizeof(text), "\x04[RANK]\x01 Игрок \x04%s\x01 в ранге \x04%i/%i\x01 набрано \x04%i\x01 очков (\x04%i\x01 до следущей позиции), \x04%i\x01 убийств и \x04%i\x01 смертей", client_name, rank, dod_global_player_count, dod_stats_score[client], delta, dod_stats_kills[client], dod_stats_deaths[client]);
	else
		Format(text, sizeof(text), "\x04[RANK]\x01 Игрок \x04%s\x01 в ранге \x04%i/%i\x01 (Ранг: \x04%s\x01) \x04%i\x01 убийств и \x04%i\x01 смертей", client_name, rank, dod_global_player_count, tableau_des_awards[x], dod_stats_kills[client], dod_stats_deaths[client]);
	
	PrintToChatAll(text);
}

public SQLQueryTop(Handle:owner, Handle:hndl, const String:error[], any:data){
	new client;
	if(hndl != INVALID_HANDLE){
		if((client = GetClientOfUserId(data))==0)
			return;
		
		new row = 0, /* top_flags, */ top_kills, top_deaths;
		decl String:top_name[64], String:text[11][256];
		new Handle:top10 = CreatePanel();
		SetPanelTitle(top10, "[RANK] Десятка лучших:");
		if(SQL_HasResultSet(hndl)){
			while(SQL_FetchRow(hndl)){
				row++;
				SQL_FetchString(hndl, 0, top_name, sizeof(top_name));
				top_kills = SQL_FetchInt(hndl, 2);
				top_deaths = SQL_FetchInt(hndl, 3);
				/*top_flags = SQL_FetchInt(hndl, 4);*/
				if(row > 3 && row <= 10)
					Format(text[row], 256, "%i. %s - %.2f У/С | %i убито",row, top_name, float(top_kills)/ (top_deaths == 0 ? 1.0 : float(top_deaths)), /*top_flags*/top_kills);
				else if(row <= 10)
					Format(text[row], 256, "%s - %.2f У/С | %i убито", top_name, float(top_kills)/ (top_deaths == 0 ? 1.0 : float(top_deaths)), /*top_flags*/top_kills);
			}
			if(row > 10)
				row = 10;
			for(new i=1;i<=row;i++){
				if(i > 3)
					DrawPanelText(top10, text[i]);
				else
					DrawPanelItem(top10, text[i]);
			}
		}
		SendPanelToClient(top10, client, Handler_DoNothing, 10);
		CloseHandle(top10);
	}
}

public SQLQueryTopGrades(Handle:owner, Handle:hndl, const String:error[], any:data){
	new client;
	if(hndl != INVALID_HANDLE){
		if((client = GetClientOfUserId(data))==0)
			return;
		
		new row = 0, top_flags, top_kills;
		decl String:top_name[64], String:text[11][256];
		new Handle:top10_awards = CreatePanel();
		SetPanelTitle(top10_awards, "[RANK] Пятерка лучших по рангам:");
		
		if(SQL_HasResultSet(hndl)){
			while(SQL_FetchRow(hndl)){
				row++;
				SQL_FetchString(hndl, 0, top_name, sizeof(top_name));
				top_flags = SQL_FetchInt(hndl, 1);
				top_kills = SQL_FetchInt(hndl, 2);
				
				new y;
				for(new i=0;i<AWARDS;i++){
					if(top_flags >= tableau_des_caps[i] && top_kills  >= tableau_des_tues[i])
						y = i;
				}
				
				if(row > 5 && row <= 5)
					Format(text[row], 256, "%i. %s | %s | %i убито", row, top_name, tableau_des_awards[y], top_kills);
				else if(row <= 5)
					Format(text[row], 256, "%s | %s | %i убито", top_name, tableau_des_awards[y], top_kills);
			}
			if(row > 5)
				row = 5;
			for(new i=1;i<=row;i++){
				if(i > 5)
					DrawPanelText(top10_awards, text[i]);
				else
					DrawPanelItem(top10_awards, text[i]);
			}
		}
		SendPanelToClient(top10_awards, client, Handler_DoNothing, 10);
		CloseHandle(top10_awards);
	}
}

public ShowStats(target, client){
	if(client <=0 || target <=0)
		return;
	
	decl String:text[256], String:client_name[64];
	GetClientName(client, client_name, sizeof(client_name));
	new Handle:statsinfo = CreatePanel();
	SetPanelTitle(statsinfo, "[RANK] Статистика игрока:");
	
	DrawPanelItem(statsinfo, "Имя");
	Format(text, sizeof(text), "%s", client_name);
	DrawPanelText(statsinfo, text);
	
	DrawPanelItem(statsinfo, "Ранг");
	new x;
	for(new i=0;i<AWARDS;i++){
		if(dod_stats_captures[client] >= tableau_des_caps[i] &&  dod_stats_kills[client]  >= tableau_des_tues[i])
			x = i;
	}
	Format(text, sizeof(text), "%s", tableau_des_awards[x]);
	DrawPanelText(statsinfo, text);
	
	/* DrawPanelItem(statsinfo, "Захвачено объектов");
	Format(text, sizeof(text), "%i", dod_stats_captures[client]);
	DrawPanelText(statsinfo, text); */
	
	DrawPanelItem(statsinfo, "Попаданий в голову");
	Format(text, sizeof(text), "%i", dod_stats_headshots[client]);
	DrawPanelText(statsinfo, text);
	
	new g_timeplayed = dod_stats_time_played[client] + (GetTime() - dod_stats_time_joined[client]);
	DrawPanelItem(statsinfo, "Итоговое время");
	Format(text, sizeof(text), "%i д %i ч %i м", g_timeplayed / 86400, (g_timeplayed % 86400) / 3600, (g_timeplayed % 3600) / 60);
	DrawPanelText(statsinfo, text);
	
	DrawPanelItem(statsinfo, "Убийств/Смертей (У/С)");
	Format(text, sizeof(text), "%i/%i - %.2f У/С", dod_stats_kills[client], dod_stats_deaths[client], float(dod_stats_kills[client])/(dod_stats_deaths[client] > 0 ? float(dod_stats_deaths[client]) : 1.0));
	DrawPanelText(statsinfo, text);
	
	/* DrawPanelItem(statsinfo, "Убил своих/Убит своими");
	Format(text, sizeof(text), "%i/%i", dod_stats_teamkills[client], dod_stats_teamkilled[client]);
	DrawPanelText(statsinfo, text); */
	
	if(client != target){
		for(new i=1;i<GetMaxClients();i++){
			if(IsClientInGame(i) && !IsFakeClient(i))
				SendPanelToClient(statsinfo, i, Handler_DoNothing, 15);
		}
	}else
		SendPanelToClient(statsinfo, target, Handler_DoNothing, 15);
	CloseHandle(statsinfo);
}

public Event_Player_Death(Handle:event, const String:name[], bool:dontBroadcast){
	if(GetConVarBool(Cvar_dodstats_enabled)){
		new victim = GetClientOfUserId(GetEventInt(event, "userid"));
		new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
		if(victim != 0 && attacker != 0 && IsClientInGame(victim) && IsClientInGame(attacker)){
			new victim_team = GetClientTeam(victim);
			new attacker_team = GetClientTeam(attacker);
			if(victim == attacker){
				dod_stats_deaths[victim] += 1;
				dod_stats_score[victim] -= 2;
			}else if(victim_team == attacker_team && victim != attacker){
				/* if(GetConVarInt(Cvar_dodstats_tk_penalty) != 0){
					dod_stats_score[attacker] -= GetConVarInt(Cvar_dodstats_tk_penalty);
					dod_stats_teamkills[attacker] += 1;
					dod_stats_teamkilled[victim] += 1; */
					dod_stats_deaths[victim] += 1;
					dod_stats_kills[attacker] += 1;
					dod_stats_score[attacker] += 1;
				//}
			}else if(victim_team != attacker_team){	
				dod_stats_deaths[victim] += 1;
				dod_stats_kills[attacker] += 1;
				dod_stats_score[attacker] += 1;
			}
			SavePlayer(victim);
			SavePlayer(attacker);
		}
	}
}

public Event_Player_Hurt(Handle:event, const String:name[], bool:dontBroadcast){
	new victim = GetClientOfUserId(GetEventInt(event, "userid"));
	new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
	if(GetConVarBool(Cvar_dodstats_enabled) && victim != 0 && attacker != 0 && IsClientInGame(victim) && IsClientInGame(attacker)){
		new hitgroup = GetEventInt(event, "hitgroup");
		new String:victim_name[64];
		new String:attacker_name[64];
		GetClientName(victim, victim_name, sizeof(victim_name));
		GetClientName(attacker, attacker_name, sizeof(attacker_name));
		if(hitgroup == 1){
 			/*PrintToChat(attacker, "\x01\x04HEADSHOT\x01 sur %s", victim_name);
			PrintToChat(victim, "\x01\x04HEADSHOT\x01 de %s", attacker_name); */
			dod_stats_headshots[attacker] += 1;
			dod_stats_score[attacker] += 1;
			SavePlayer(attacker);
		}
	}
}

public Event_Point_Captured(Handle:event, const String:name[], bool:dontBroadcast){
	if(GetConVarBool(Cvar_dodstats_enabled)){
		new client;
		new String:cappers[256];
		GetEventString(event,"cappers",cappers,sizeof(cappers));
		for(new i=0;i<strlen(cappers);i++) {
			client = cappers[i];
			dod_stats_captures[client] += 1;
			dod_stats_score[client] += 2;
		}
		SavePlayer(client);
	}
}

public SavePlayer(client){
	if(db == INVALID_HANDLE || GetConVarInt(Cvar_dodstats_enabled) == 0 || !IsPlayerAlive(client))
		return;
	decl String:client_name[256], String:client_steamid[128];
	GetClientName(client, client_name, sizeof(client_name));
	ReplaceString(client_name, sizeof(client_name), "'", "");
	GetClientAuthString(client, client_steamid, sizeof(client_steamid));
	decl String:query[255];
	Format(query, sizeof(query), "UPDATE dod_stats SET name = '%s', score = '%i', kills = '%i', deaths = '%i', captures = '%i', headshots = '%i', teamkills = '%i', teamkilled = '%i', timeplayed = '%i' WHERE steamid = '%s'", client_name, dod_stats_score[client], dod_stats_kills[client], dod_stats_deaths[client], dod_stats_captures[client], dod_stats_headshots[client], dod_stats_teamkills[client], dod_stats_teamkilled[client], dod_stats_time_played[client] + (GetTime() - dod_stats_time_joined[client]), client_steamid);
	SQL_TQuery(db, SQLErrorCheckCallback, query);
}

public Action:InfoDodStats(Handle:timer, any:client){
	Cvar_InfoDodStats[client] = INVALID_HANDLE;
	if(GetConVarInt(Cvar_dodstats_enabled) && IsClientConnected(client) && IsClientInGame(client)){
		/* new String:client_name[64];
		new String:ip[32];
		new String:country[46];
		GetClientName(client, client_name, sizeof(client_name));
		GetClientIP(client, ip, 19);
		GeoipCountry(ip, country, sizeof(country));
		new x;
		for(new i=0;i<AWARDS;i++){
			if(dod_stats_captures[client] >= tableau_des_caps[i] && dod_stats_kills[client] >= tableau_des_tues[i])
				x = i;
		} */
	PrintToChat(client, "\x04Добро пожаловать! \n\x05Чтобы связаться с админом напишите \x04/report"/* , country, client_name, tableau_des_awards[x] */);
	PrintToChat(client, "\x05Если у Вас высокий пинг напишите в чате \x04/proxy");
	}
}

public Handler_DoNothing(Handle:menu, MenuAction:action, param1, param2){
	//Nothing
}